pub trait Summary {
  fn summary(&self) -> String;
}

pub struct BlogPost {
  pub title: String,
  pub author: String,
  pub content: String,
}

impl Summary for BlogPost {
  fn summary(&self) -> String {
      format!("{} by {}", self.title, self.author)
  }
}

// 只能返回特定类型
pub fn new_blog_post(title: String, author: String, content: String) -> impl Summary {
  BlogPost {
      title,
      author,
      content,
  }
}

fn main() {
  let p = new_blog_post(
      String::from("some title"),
      String::from("xiexianbin"),
      String::from("abcd23"));
  println!("{}", p.summary());
}
